import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:rw_voice/rw_voice.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _voiceResult = 'Error';

  @override
  void initState() {
    super.initState();
    initVoiceResultState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initVoiceResultState() async {
    String voiceResult;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      voiceResult = await RwVoice.voiceResult();
    } on PlatformException {
      voiceResult = 'Failed to get voice input.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _voiceResult = voiceResult;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app - voice'),
        ),
        body: Center(
          child: Text('Voice result is: $_voiceResult\n'),
        ),
      ),
    );
  }
}
